<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

class VI_WOOCOMMERCE_COUPON_BOX_DATA {
	private $params;
	private $default;

	/**
	 * VI_WOOCOMMERCE_COUPON_BOX_DATA constructor.
	 * Init setting
	 */
	public function __construct() {

		global $coupon_box_settings;
		if ( ! $coupon_box_settings ) {
			$coupon_box_settings = get_option( 'woo_coupon_box_params', array() );
		}
		$this->default = array(
			/*old option*/
			'wcb_active'                                    => 1,
			'wcb_language'                                  => '',
			'wcb_multi_language'                            => '',
			'wcb_coupon'                                    => '',
			'wcb_email_campaign'                            => '',
			'wcb_enable_mailchimp'                          => '',
			'wcb_mailchimp_double_optin'                    => '',
			'wcb_unsub_mailchimp'                           => '',
			'wcb_api'                                       => '',
			'wcb_mlists'                                    => '',
			'wcb_assign_home'                               => '',
			'wcb_assign'                                    => '',
			/*new options*/
			'wcb_coupon_select'                             => 'unique',
			'wcb_coupon_custom'                             => '',
			'wcb_coupon_unique_amount'                      => 10,
			'wcb_coupon_unique_expires_type'                => 'after',
			'wcb_coupon_unique_date_expires'                => 30,
			'wcb_coupon_unique_date_expire_fixed'           => '',
			'wcb_coupon_unique_discount_type'               => 'percent',
			'wcb_coupon_unique_description'                 => '',
			'wcb_coupon_unique_individual_use'              => false,
			'wcb_coupon_unique_product_ids'                 => array(),
			'wcb_coupon_unique_excluded_product_ids'        => array(),
			'wcb_coupon_unique_usage_limit'                 => 0,
			'wcb_coupon_unique_usage_limit_per_user'        => 0,
			'wcb_coupon_unique_limit_usage_to_x_items'      => null,
			'wcb_coupon_unique_free_shipping'               => false,
			'wcb_coupon_unique_product_categories'          => array(),
			'wcb_coupon_unique_excluded_product_categories' => array(),
			'wcb_coupon_unique_exclude_sale_items'          => false,
			'wcb_coupon_unique_minimum_amount'              => '50',
			'wcb_coupon_unique_maximum_amount'              => '100',
			'wcb_coupon_unique_email_restrictions'          => true,
			'wcb_coupon_unique_prefix'                      => '',

			'wcb_email_template_customizer_enable' => 0,
			'wcb_email_template'                   => '',
			'wcb_email_enable'                     => 1,
			'wcb_email_subject'                    => 'Thank you for subscribing',
			'wcb_email_heading'                    => '{coupon_value} OFF DISCOUNT COUPON CODE OFFER',
			'wcb_email_content'                    => 'Thanks for signing up for our newsletter.

Enjoy your discount code for {coupon_value} OFF until {last_valid_date}. Don\'t miss out this great chance on our shop.

{coupon_code}

{shop_now}',
			'wcb_button_shop_now_title'            => 'Shop Now',
			'wcb_button_unsubscribe_title'         => 'Unsubscribe',
			'wcb_button_unsubscribe_content'       => 'You have successfully unsubscribed from our coupon box emails.',
			'wcb_button_shop_now_url'              => get_bloginfo( 'url' ),
			'wcb_button_shop_now_size'             => '16',
			'wcb_button_shop_now_color'            => '#fff',
			'wcb_button_shop_now_bg_color'         => '#52d2aa',
			'wcb_button_shop_now_border_radius'    => '30',

			'wcb_disable_login' => 1,
			'wcb_select_popup'  => 'time',
			'wcb_popup_time'    => '3,10',
			'wcb_popup_scroll'  => '50',
			'wcb_popup_exit'    => '50',
			'wcb_on_close'      => 'hide',

			'wcb_expire'                 => '1',
			'wcb_expire_unit'            => 'hour',
			'wcb_expire_subscribed'      => '360',
			'wcb_layout'                 => 3,
			'wcb_purchased_code'         => '',
			'wcb_enable_active_campaign' => '',
			'wcb_active_campaign_api'    => '',
			'wcb_active_campaign_url'    => '',
			'wcb_unsub_active_campaign'  => '',
			'wcb_active_campaign_list'   => '',

			'wcb_enable_sendgrid' => '',
			'wcb_sendgrid_api'    => '',
			'wcb_sendgrid_list'   => '',

			'wcb_enable_klaviyo' => '',
			'wcb_klaviyo_api'    => '',
			'wcb_klaviyo_list'   => '',

			'wcb_enable_sendinblue' => '',
			'wcb_sendinblue_api'    => '',
			'wcb_sendinblue_list'   => [],

			'wcb_enable_getresponse' => '',
			'wcb_getresponse_api'    => '',
			'wcb_getresponse_list'   => '',

			'wcb_enable_hubspot' => '',
			'wcb_hubspot_api'    => '',

			'wcb_enable_mailpoet' => '',
			'wcb_mailpoet_list'   => [],

			'wcb_social_icons_size'             => '50',
			'wcb_social_icons_target'           => '_blank',
			'wcb_social_icons_facebook_url'     => '',
			'wcb_social_icons_facebook_select'  => 'wcb_social_icons-facebook-app-logo',
			'wcb_social_icons_facebook_color'   => '#3b579d',
			'wcb_social_icons_twitter_url'      => '',
			'wcb_social_icons_twitter_select'   => 'wcb_social_icons-twitter-1',
			'wcb_social_icons_twitter_color'    => '#3CF',
			'wcb_social_icons_pinterest_url'    => '',
			'wcb_social_icons_pinterest_select' => 'wcb_social_icons-pinterest-social-logo',
			'wcb_social_icons_pinterest_color'  => '#BD081C',
			'wcb_social_icons_instagram_url'    => '',
			'wcb_social_icons_instagram_select' => 'wcb_social_icons-instagram',
			'wcb_social_icons_instagram_color'  => '#6a453b',
			'wcb_social_icons_dribbble_url'     => '',
			'wcb_social_icons_dribbble_select'  => 'wcb_social_icons-dribbble-logo-1',
			'wcb_social_icons_dribbble_color'   => '#F26798',
			'wcb_social_icons_tumblr_url'       => '',
			'wcb_social_icons_tumblr_select'    => 'wcb_social_icons-tumblr-logo-2',
			'wcb_social_icons_tumblr_color'     => '#32506d',
			'wcb_social_icons_google_url'       => '',
			'wcb_social_icons_google_select'    => 'wcb_social_icons-google-plus-social-logotype-1',
			'wcb_social_icons_google_color'     => '#DC4A38',
			'wcb_social_icons_vkontakte_url'    => '',
			'wcb_social_icons_vkontakte_select' => 'wcb_social_icons-vk-social-logotype-1',
			'wcb_social_icons_vkontakte_color'  => '#45668e',
			'wcb_social_icons_linkedin_url'     => '',
			'wcb_social_icons_linkedin_select'  => 'wcb_social_icons-linkedin-logo-1',
			'wcb_social_icons_linkedin_color'   => '#007bb5',
			'wcb_social_icons_youtube_url'      => '',
			'wcb_social_icons_youtube_select'   => 'wcb_social_icons-youtube-logotype',
			'wcb_social_icons_youtube_color'    => '#ff0000',
			'wcb_view_mode'                     => '1',
			'wcb_show_coupon'                   => '',
			'wcb_border_radius'                 => 25,
			'wcb_title'                         => 'WANT <span>10% OFF?</span>',
			'wcb_title_size'                    => '94',
			'wcb_title_space'                   => '20',
			'wcb_color_header'                  => '',
			'wcb_bg_header'                     => '',
			'wcb_header_bg_img'                 => '',
			'wcb_header_bg_img_repeat'          => 'no-repeat',
			'wcb_header_bg_img_size'            => 'contain',
			'wcb_header_bg_img_position'        => 'center',
			'wcb_header_font'                   => wp_json_encode(
				array(
					'font' => 'Open Sans',
				) ),

			'wcb_body_font' => wp_json_encode(
				array(
					'font' => 'Open Sans',
				) ),


			'wcb_body_bg'                   => '#f4fbff',
			'wcb_body_bg_img'               => VI_WOOCOMMERCE_COUPON_BOX_IMAGES . 'bg-sale.jpg',
			'wcb_body_bg_img_repeat'        => 'no-repeat',
			'wcb_body_bg_img_size'          => 'cover',
			'wcb_body_bg_img_position'      => '0% 0%',
			'wcb_body_text_color'           => '#ffffff',
			'wcb_message'                   => 'Subscribe now to get free discount coupon code. Don\'t miss out!',
			'wcb_message_after_subscribe'   => 'Congratulation! You have subscribed successfully. Please check out your mailbox to see the coupon code.',
			'wcb_color_message'             => '',
			'wcb_message_size'              => '14',
			'wcb_message_align'             => 'center',
			'wcb_follow_us'                 => '',
			'wcb_color_follow_us'           => '',
			'wcb_button_text'               => 'SUBSCRIBE',
			'wcb_button_text_color'         => '#ffffff',
			'wcb_button_bg_color'           => '#ff1452',
			'wcb_button_border_radius'      => 4,
			'wcb_email_input_placeholder'   => 'Enter your email address',
			'wcb_email_input_border_radius' => 4,
			'wcb_email_button_space'        => 0,
			'wcb_email_input_color'         => '#000000',
			'wcb_email_input_bg_color'      => '',

			'wcb_footer_text'                       => 'We will never spam you, unsubscribe anytime.',
			'wcb_footer_text_after_subscribe'       => 'Thank you for subscription',
			'wcb_popup_type'                        => 'wcb-md-effect-1',
			'alpha_color_overlay'                   => 'rgba(29, 29, 29, 0.8)',
			'wcb_register_account_checkbox'         => 1,
			'wcb_register_account_checkbox_checked' => 1,
			'wcb_register_account_message'          => 'I agree register a new account',
			'wcb_restrict_domain'                   => '',
			'wcb_gdpr_checkbox'                     => 1,
			'wcb_gdpr_checkbox_checked'             => 0,
			'wcb_gdpr_message'                      => 'I agree with the <a href="">term and condition</a>',
			'wcb_custom_css'                        => '',
			'wcb_effect'                            => '',

			'wcb_button_close'               => 'wcb_button_close_icons-close',
			'wcb_button_close_size'          => '16',
			'wcb_button_close_width'         => '36',
			'wcb_button_close_color'         => '#000000',
			'wcb_button_close_bg_color'      => 'rgba(255,255,255,0.7)',
			'wcb_button_close_border_radius' => '20',
			'wcb_button_close_position_x'    => '11',
			'wcb_button_close_position_y'    => '11',

			'wcb_right_column_size'            => 50,
			'wcb_right_column_size_px'         => 300,
			'wcb_right_column_bg'              => '#ffffff',
			'wcb_right_column_bg_img'          => '',
			'wcb_right_column_bg_img_repeat'   => 'no-repeat',
			'wcb_right_column_bg_img_size'     => 'cover',
			'wcb_right_column_bg_img_position' => 'center',

			'wcb_custom_image_block'        => 0,
			'wcb_custom_image_img'          => '',
			'wcb_custom_image_width'        => 100,
			'wcb_custom_image_height'       => 10,
			'wcb_custom_image_top'          => '',
			'wcb_custom_image_bottom'       => '',
			'wcb_custom_image_left'         => '',
			'wcb_custom_image_right'        => '',
			'wcb_custom_image_bsize'        => 'cover',
			'wcb_custom_image_index'        => 1,

			'wcb_popup_icon_enable'        => 0,
			'wcb_popup_icon'               => 'wcb_giftbox-gift-with-ribbon',
			'wcb_popup_icon_position'      => 'bottom-right',
			'wcb_popup_icon_size'          => '30',
			'wcb_popup_icon_color'         => '#ffffff',
			'wcb_popup_icon_bg_color'      => '#9632dc',
			'wcb_popup_icon_border_radius' => '8',
			'wcb_popup_icon_mobile'        => '',

			'wcb_input_name'                 => 0,
			'wcb_input_name_required'        => 0,
			'wcb_input_lname'                => 0,
			'wcb_input_lname_required'       => 0,
			'wcb_input_mobile'               => 0,
			'wcb_input_mobile_required'      => 0,
			'wcb_input_birthday'             => 0,
			'wcb_input_birthday_required'    => 0,
			'wcb_input_gender'               => 0,
			'wcb_input_gender_required'      => 0,
			'wcb_input_additional'           => 0,
			'wcb_input_additional_required'  => 0,
			'wcb_input_additional_type'      => 'text',
			'wcb_input_additional_label'     => 'Additional information',
			'wcb_custom_input_border_radius' => 0,
			'wcb_custom_input_color'         => '#000',
			'wcb_custom_input_bg_color'      => '#fff',

			'ajax_endpoint'                     => 'ajax',

			/*new option 2.0.4.5*/
			'wcb_title_after_subscribing'       => 'Subscribed successfully!',
			'wcb_recaptcha'                     => 0,
			'wcb_recaptcha_version'             => 2,
			'wcb_recaptcha_site_key'            => '',
			'wcb_recaptcha_secret_key'          => '',
			'wcb_recaptcha_secret_theme'        => 'light',
			'wcb_recaptcha_position'            => 'after',
			'wcb_never_reminder_enable'         => 0,
			'wcb_no_thank_button_enable'        => 0,
			'wcb_no_thank_button_title'         => 'No, thanks',
			'wcb_no_thank_button_color'         => '#fff',
			'wcb_no_thank_button_bg_color'      => '#5e656b',
			'wcb_no_thank_button_border_radius' => '4',
			'email_template'                    => '',
			'email_template_for_register'       => '',
			'wcb_register_account'              => 0,
			'wcb_register_email_content'        => 'Your account has been created.

Here is your credential:

Username: {wcb_user_name}

Password: {wcb_password}'
		);
		$this->params  = apply_filters( 'woo_coupon_box_params', wp_parse_args( $coupon_box_settings, $this->default ) );
	}

	public function get_language() {
		return $this->params['wcb_language'];
	}

	public function get_params( $name = "", $language = "" ) {
		$language = apply_filters( 'woo_coupon_box_params_language', $language, $name );

		if ( ! $name ) {
			return $this->params;
		} elseif ( isset( $this->params[ $name ] ) ) {
			if ( $language ) {
				$name_language = $name . '_' . $language;
				if ( isset( $this->params[ $name_language ] ) ) {
					return apply_filters( 'woo_coupon_box_params_' . $name_language, $this->params[ $name_language ] );
				} else {
					return apply_filters( 'woo_coupon_box_params_' . $name_language, $this->params[ $name ] );
				}
			} else {
				return apply_filters( 'woo_coupon_box_params_' . $name, $this->params[ $name ] );
			}
		} else {
			return false;
		}
	}

	public function get_default( $name = "" ) {
		if ( ! $name ) {
			return $this->default;
		} elseif ( isset( $this->default[ $name ] ) ) {
			return apply_filters( 'woo_coupon_box_params_default_' . $name, $this->default[ $name ] );
		} else {
			return false;
		}
	}

	public static function email_template_customizer_active() {
		return ( class_exists( 'WooCommerce_Email_Template_Customizer' ) || class_exists( 'Woo_Email_Template_Customizer' ) );
	}

	public static function get_email_templates( $type = 'wcb_email' ) {
		return self::email_template_customizer_active() ? viwec_get_emails_list( $type ) : array();
	}

	public function get_current_campaign( $email_campaign ) {
		$return_campaign = [];
		if ( ! is_array( $email_campaign ) ) {
			return [ $email_campaign ];
		}
		foreach ( $email_campaign as $condition ) {
			if ( ! is_array( $condition ) || ! isset( $condition['campaign'] ) || ! isset( $condition['from'] ) ||
			     ! isset( $condition['to'] ) || empty( $condition['campaign'] ) ) {
				continue;
			}
			$current_time = current_time('U');
			if ( ! empty( $condition['from'] ) ) {
				$from_time = strtotime( $condition['from'] );
				if ( $from_time > $current_time ) {
					continue;
				}
			}
			if ( ! empty( $condition['to'] ) ) {
				$from_time = strtotime( $condition['to'] );
				if ( $from_time < $current_time ) {
					continue;
				}
			}
			$convert_campaign = explode(',', $condition['campaign'] );
			foreach ( $convert_campaign as $cp_val ) {
				if ( ! in_array( $cp_val, $return_campaign ) ) {
					$return_campaign[] = $cp_val;
				}
			}
		}
		return $return_campaign;
	}
}

new VI_WOOCOMMERCE_COUPON_BOX_DATA();
